unit c_unicode;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, StdCtrls, TypInfo;

type
  TEncodeFlags = (efUnknown, efAnsi, efUnicode, efUncodeBigEn, efUTF8);
  TUTF8Falg = packed record
    EF, BB, BF: Byte;
  end;

const
  Encode: TUTF8Falg = (EF: $EF; BB: $BB; BF: $BF);  
//Unicode=============================================================================
procedure UnicodeToUTF8Stream(const Text: widestring; var Stream: TStream);
procedure AnsiStringToUTF8Stream(const Text: widestring; var Stream: TStream);
function ChAnsiToWide(const StrA: AnsiString): WideString;
//Unicode=============================================================================


//Muli-Language=======================================================================
function IsAPropExist(AInst: TObject; const PropName: string): Boolean;
//Muli-Language=======================================================================

implementation

procedure UnicodeToUTF8Stream(const Text: widestring; var Stream: TStream);
var
  StrW: WideString;
  L: Integer;
  UTF8_Str: UTF8String;
begin
  try
    if Text <> '' then
    begin
      StrW := Text;
      SetLength(UTF8_Str, Length(StrW) * 3); // SetLength includes space for null terminator
      L := UnicodeToUtf8(PChar(UTF8_Str), Length(UTF8_Str)+1, PWideChar(StrW), Length(StrW));
      if L > 0 then
        SetLength(UTF8_Str, L-1)
      else
        UTF8_Str := '';
      Stream.Write(Encode, SizeOf(Encode));
      Stream.Write(UTF8_Str[1], Length(UTF8_Str));
    end
    else
      Stream.Write(Encode, SizeOf(Encode));
  except
    SetLength(StrW, 0);
  end;
end;

procedure AnsiStringToUTF8Stream(const Text: widestring; var Stream: TStream);
var
  StrW: WideString;
  L: Integer;
  UTF8_Str: UTF8String;
begin
  try
    if Text <> '' then
    begin
      StrW := ChAnsiToWide(Text);
      SetLength(UTF8_Str, Length(StrW) * 3); // SetLength includes space for null terminator
      L := UnicodeToUtf8(PChar(UTF8_Str), Length(UTF8_Str)+1, PWideChar(StrW), Length(StrW));
      if L > 0 then
        SetLength(UTF8_Str, L-1)
      else
        UTF8_Str := '';
      Stream.Write(Encode, SizeOf(Encode));
      Stream.Write(UTF8_Str[1], Length(UTF8_Str));
    end
    else
      Stream.Write(Encode, SizeOf(Encode));
  except
    SetLength(StrW, 0);
  end;
end;

function ChAnsiToWide(const StrA: AnsiString): WideString;
var
  nLen: integer;
begin
  Result := StrA;
  if Result <> '' then
  begin
    nLen := MultiByteToWideChar(936, 1, PChar(@StrA[1]), -1, nil, 0);
    SetLength(Result, nLen - 1);
    if nLen > 1 then
      MultiByteToWideChar(936, 1, PChar(@StrA[1]), -1, PWideChar(@Result[1]), nLen - 1);
  end;
end;

function IsAPropExist(AInst: TObject; const PropName: string): Boolean;
var
  PropInfo: PPropInfo;
begin
  Result := False;
  PropInfo := GetPropInfo(AInst, PropName);
  if PropInfo <> nil then
    Result := PropInfo.Name = PropName;
end;

end.
